Subject: Re: [tip: locking/core] lockdep: Fix lockdep recursion

From: "Paul E. McKenney" <[email-masked]>
Date: Wed, 28 Oct 2020 14:02:28 -0700

On Wed, Oct 28, 2020 at 04:08:59PM -0400, Qian Cai wrote:
> On Wed, 2020-10-28 at 08:53 -0700, Paul E. McKenney wrote:
> > On Wed, Oct 28, 2020 at 10:39:47AM -0400, Qian Cai wrote:
> > > On Tue, 2020-10-27 at 20:01 -0700, Paul E. McKenney wrote:
> > > > If I have the right email thread associated with the right fixes, these
> > > > commits in -rcu should be what you are looking for:
> > > > 
> > > > 73b658b6b7d5 ("rcu: Prevent lockdep-RCU splats on lock
> > > > acquisition/release")
> > > > 626b79aa935a ("x86/smpboot:  Move rcu_cpu_starting() earlier")
> > > > 
> > > > And maybe this one as well:
> > > > 
> > > > 3a6f638cb95b ("rcu,ftrace: Fix ftrace recursion")
> > > > 
> > > > Please let me know if these commits do not fix things.
> > > While those patches silence the warnings for x86. Other arches are still
> > > suffering. It is only after applying the patch from Boqun below fixed
> > > everything.
> > 
> > Fair point!
> > 
> > > Is it a good idea for Boqun to write a formal patch or we should fix all
> > > arches
> > > individually like "x86/smpboot: Move rcu_cpu_starting() earlier"?
> > 
> > By Boqun's patch, you mean the change to debug_lockdep_rcu_enabled()
> > shown below?  Peter Zijlstra showed that real failures can happen, so we
> 
> Yes.
> 
> > do not want to cover them up.  So we are firmly in "fix all architectures"
> > space here, sorry!
> > 
> > I am happy to accumulate those patches, but cannot commit to creating
> > or testing them.
> 
> Okay, I posted 3 patches for each arch and CC'ed you.

Very good!  I have acked them.

>                                                       BTW, it looks like
> something is wrong on @vger.kernel.org today where I received many of those,
> 
> 4.7.1 Hello [216.205.24.124], for recipient address <[email-masked]> the policy analysis reported: zpostgrey: connect: Connection refused
> 
> and I can see your previous mails did not even reach there either.
> 
> https://lore.kernel.org/lkml/

It does seem to be having some difficulty, and some people are looking
into it.  Hopefully soon someone who can actually make the needed
changes.  ;-)

							Thanx, Paul